package com.example.devicetopiclinux.Topic.H2Client;

import com.alibaba.cloudapi.sdk.model.ApiResponse;
import com.alibaba.fastjson.JSON;
import com.aliyun.iotx.api.client.IoTApiClientBuilderParams;
import com.aliyun.iotx.api.client.IoTApiRequest;
import com.aliyun.iotx.api.client.SyncApiClient;
import com.aliyun.openservices.iot.api.Profile;
import com.aliyun.openservices.iot.api.message.MessageClientFactory;
import com.aliyun.openservices.iot.api.message.api.MessageClient;
import com.aliyun.openservices.iot.api.message.callback.MessageCallback;
import com.aliyun.openservices.iot.api.message.entity.Message;
import device.devicedemolinux.Topic.TopicDeviceModel.DeviceResultDTO1;
import device.devicedemolinux.Topic.TopicDeviceModel.DeviceResultDTO3;

import java.io.UnsupportedEncodingException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.List;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;

/**
 * H2设备消息订阅---获取productKey、deviceName、deviceSecret信息，----订阅设备消息
 */
public class H2Client {
    public static void main(String[] args) {
        MyThread01 myThread01 = new MyThread01();
        myThread01.start();
        MyThread02 myThread02 = new MyThread02();
        myThread02.start();
    }

    /**
     * /app/thing/list---接口查询设备的基本信息
     * <p>
     * <p>
     * 返回结果示例：response code = 200 response = {"code":200,"data":{"total":2,"data":[{"activeTime":"2019-08-06 11:33:50","productKey":"a13TLBPrC0d","nodeType":0,"deviceName":"wkzijitianjiashebei","utcCreateTime":"2019-08-06T03:32:07.000Z","productName":"瑞为产品测试3个设备","utcActiveTime":"2019-08-06T03:33:50.343Z","utcLastOnlineTime":"2019-08-06T09:54:15.955Z","createTime":"2019-08-06 11:32:07","lastOnlineTime":"2019-08-06 17:54:15","status":"OFFLINE"},{"activeTime":"2019-07-31 15:29:59","productKey":"a1CHWKtQhTN","nodeType":0,"deviceName":"yHgpeulcFbBHQ9VwudbV","utcCreateTime":"2019-07-31T06:43:23.000Z","productName":"闸机设备","utcActiveTime":"2019-07-31T07:29:59.218Z","utcLastOnlineTime":"2019-08-04T16:00:32.864Z","createTime":"2019-07-31 14:43:23","lastOnlineTime":"2019-08-05 00:00:32","status":"OFFLINE"}],"pageNo":1,"pageSize":20},"id":"00d77cec-4f52-431e-9ed7-f5278afc061c"}
     */
    public static class MyThread01 extends Thread {
        public void run() {
            try {
                IoTApiClientBuilderParams ioTApiClientBuilderParams = new IoTApiClientBuilderParams();
                ioTApiClientBuilderParams.setAppKey("27745650");
                ioTApiClientBuilderParams.setAppSecret("81636d8bdaf817a60e68f9cd8f1c8efe");
                SyncApiClient syncClient = new SyncApiClient(ioTApiClientBuilderParams);
                IoTApiRequest request = new IoTApiRequest();
                //设置api的版本
                request.setApiVer("1.0.0");
                request.putParam("Action", "QueryDevice");
                //如果需要登陆，设置当前的会话的token
                request.setIotToken("xxxxxxxxxxxxxxx");
                request.putParam("ProductKey", "1");
                request.putParam("PageSize", "10");
                request.putParam("CurrentPage", "1");
                request.putParam("Format", "JSON");
                //请求参数域名、path、request
                request.setVersion("1.0");// 请求协议版本
                System.out.println(request);
                //请求参数域名、path、request
                ApiResponse response = null;
                try {
                    response = syncClient.postBody("api.link.aliyun.com",
                            "/app/thing/list", request, true);
                } catch (UnsupportedEncodingException e) {
                    e.printStackTrace();
                }
                try {
                    System.out.println("response code = " + response.getCode()
                            + " response = " + new String(response.getBody(), "UTF-8"));
                } catch (UnsupportedEncodingException e) {
                    e.printStackTrace();
                }
                if (response.getCode() == 200) {
                    String Data = null;
                    try {
                        Data = new String(response.getBody(), "UTF-8");
                    } catch (UnsupportedEncodingException e) {
                        e.printStackTrace();
                    }
                    DeviceResultDTO1 deviceResultDTO1 = JSON.parseObject(Data, DeviceResultDTO1.class);
                    if (deviceResultDTO1 != null) {

                        List<DeviceResultDTO3> list = deviceResultDTO1.getData().getData();

                        for (DeviceResultDTO3 deviceResultDTO3 : list) {
                            String productName = deviceResultDTO3.getProductName();
                            String productKey = deviceResultDTO3.getProductKey();
                            String deviceName = deviceResultDTO3.getDeviceName();
                            System.out.println(productKey);
                            System.out.println(productName);
                            System.out.println(deviceName);


                        }

                    }
                }
                Thread.sleep((int) (Math.random() * 1000));
                System.out.println("run = " + Thread.currentThread().getName());

            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * H2进行消息订阅（分为自定义topic订阅和非自定义的topic订阅）--payload为消息体
     * 消息示例：receive message from Message{payload=13123141421, topic='/a13TLBPrC0d/wkzijitianjiashebei/user/wkget', messageId='1158924795132311552', qos=0, generateTime=1565144177598}
     */
    public static class MyThread02 extends Thread {
        public void run() {
            try {
                // TODO 从控制台获取productKey、deviceName、deviceSecret信息，也就是上面查询获取到值
                /**
                 * 配置参数
                 */
                // TODO 从控制台获取productKey、deviceName、deviceSecret信息
                String productKey = "a1IltmJSn1V";
                String deviceName = "yjj120402";
                //从控制台获取deviceSecret自己填写的
                String deviceSecret = "lTpTFVV2j3hlLMJe3ZODRTrr0SYDuzwj";
                // region固定写死的
                String region = "cn-shanghai";

                // TODO 去产品的TOpic类自定义一个topic作为消息测试的topic
                // TODO 测试时候需要到设备的自定义topic进行消息的发布或者订阅
                // 用于测试的topic
                /**
                 * subTopic-自定义topic---以此为例
                 * pubTopic-非自定义topic
                 */
                String subTopic = "/" + productKey + "/" + deviceName + "/user/wkget";
                String pubTopic = "/" + productKey + "/" + deviceName + "/update";
                // endPoint:  https://${uid}.iot-as-http2.${region}.aliyuncs.com
                String endPoint = "https://" + productKey + ".iot-as-http2." + region + ".aliyuncs.com";

                // 客户端设备唯一标记
                String clientId = InetAddress.getLocalHost().getHostAddress();

                // 连接配置
                Profile profile = Profile.getDeviceProfile(endPoint, productKey, deviceName, deviceSecret, clientId);

                // 如果是true 那么清理所有离线消息，即qos1 或者 2的所有未接收内容
                profile.setCleanSession(false);

                // 构造客户端
                MessageClient client = MessageClientFactory.messageClient(profile);

                // 数据接收
                client.connect(messageToken -> {
                    Message m = messageToken.getMessage();
                    System.out.println("receive message from " + m);
                    System.out.println("receive message from " + m);
                    System.out.println("receive message from " + m);
                    return MessageCallback.Action.CommitSuccess;
                });
                /**
                 * 订阅topic
                 * @param  topic              topic
                 * @return completableFuture  for subscribe result
                 */
                CompletableFuture subFuture = client.subscribe(subTopic);
                System.out.println("sub result : " + subFuture.get());
                System.out.println("sub result : " + subFuture.get());
                System.out.println("sub result : " + subFuture.get());
                System.out.println("sub result : " + subFuture.get());
//                Thread.sleep((int) (Math.random() * 1000));
                System.out.println("run = " + Thread.currentThread().getName());

                /**
                 * 订阅topic,并制定该topic回调
                 * @param  topic              topic
                 * @param  messageCallback    callback when message is received on this topic
                 * @return completableFuture  for subscribe result
                 */
//                MessageCallback messageCallback = new MessageCallback() {
//                    @Override
//                    public Action consume(MessageToken messageToken) {
//                        Message m = messageToken.getMessage();
//                        System.out.println("receive message from " + m);
//                        return Action.CommitAckManually;
//                    }
//                };
//                client.subscribe(subTopic, messageCallback);
                /**
                 * 取消订阅
                 *
                 * @param  topic               topic
                 * @return completableFuture   for unsubscribe result
                 */
//                client.unsubscribe(subTopic);
//                System.out.println("sub result : " + "订阅取消");

                /**
                 * 发布消息
                 *
                 * @param  topic               topic
                 * @return completableFuture   for unsubscribe result
                 */
//                MessageToken messageToken = client.publish(pubTopic, new Message("hello iot".getBytes(), 0));
//                System.out.println("publish success, messageId: " + messageToken.getPublishFuture().get().getMessageId());

            } catch (InterruptedException e) {
                e.printStackTrace();
            } catch (UnknownHostException e) {
                e.printStackTrace();
            } catch (ExecutionException e) {
                e.printStackTrace();
            }

        }

    }
}
