package com.example.devicetopiclinux.Topic.IotAppkeyiClient;

import com.aliyun.openservices.iot.api.Profile;
import com.aliyun.openservices.iot.api.message.MessageClientFactory;
import com.aliyun.openservices.iot.api.message.api.MessageClient;
import com.aliyun.openservices.iot.api.message.callback.MessageCallback;
import com.aliyun.openservices.iot.api.message.entity.MessageToken;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;

/**
 * @author yuxing.liyuxing@alibaba-inc.com
 * @date 2019/8/28
 */
@Component
public class IotAppkeyiClient {
    private Logger logger = LoggerFactory.getLogger(this.getClass());
    //system.getenv("iot.hosting.appKey")appkey和appsecret可以重环境变量中获取
    String appKey = System.getenv("iot.hosting.appKey");
     String appSecret=System.getenv("iot.hosting.appSecret");
    @Value("${iot.http2.host}")
    private String httpHost;
    @PostConstruct
    public void init() {

        Profile profile = Profile.getAppKeyProfile(httpHost, appKey, appSecret);
        MessageClient messageClient = MessageClientFactory.messageClient(profile);
        profile.setCleanSession(false);
        try {
            messageClient.connect(messageToken -> {
                return MessageCallback.Action.CommitSuccess;
            });
        } catch (Throwable ex) {
            logger.info("init h2 client exception", ex);


            System.out.println(ex);
        }
        MessageCallback messageCallback = new MessageCallback() {
            @Override
            public Action consume(MessageToken messageToken) {
                logger.info("receive https msg {}", messageToken);
                ThingMsgRecordDO recordDO = new ThingMsgRecordDO();
                recordDO.setTopic(messageToken.getMessage().getTopic());
                recordDO.setPayload(new String(messageToken.getMessage().getPayload()));
                System.out.println(recordDO);
                System.out.println(recordDO);
                System.out.println(recordDO);
                return Action.CommitSuccess;
            }
        };
        String topic = String.format("/a13TLBPrC0d/wkzijitianjiashebei/user/wkget", appKey);
        messageClient.setMessageListener(topic, messageCallback);
    }

}
